## chromium-browser 6.0.472.63~r59945

=== src/native_client/SConstruct ===
# -*- python -*-
# Copyright 2008 The Native Client Authors.  All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

import atexit
import glob
import os
import stat
import subprocess
import sys
sys.path.append("./common")
import sets

from SCons.Errors import UserError
from SCons.Script import GetBuildFailures

# NOTE: Underlay for  src/third_party_mod/gtest
# TODO: try to eliminate this hack
Dir('src/third_party_mod/gtest').addRepository(
    Dir('#/../testing/gtest'))


# ----------------------------------------------------------
# REPORT
# ----------------------------------------------------------
def PrintFinalReport():
  failures = GetBuildFailures()
  if not failures:
    return

  print
  print '*' * 70
  print 'ERROR REPORT: %d failures' % len(failures)
  print '*' * 70
  print
  for f in failures:
    print "%s failed: %s\n" % (f.node, f.errstr)

atexit.register(PrintFinalReport)


def VerboseConfigInfo(env):
  "Should we print verbose config information useful for bug reports"
  if '--help' in sys.argv: return False
  if env.Bit('prebuilt') or ARGUMENTS.get('built_elsewhere'): return False
  return ARGUMENTS.get('sysinfo', True)

# ----------------------------------------------------------
# SANITY CHECKS
# ----------------------------------------------------------

ACCEPTABLE_ARGUMENTS = {
    # TODO: add comments what these mean
    # TODO: check which ones are obsolete
    ####  ASCII SORTED ####
    'COVERAGE': None,
    'DOXYGEN': None,
    'LOAD': None,
    'MODE': None,
    'PROFILE': None,
    'PROGRESS': None,
    'SILENT': None,
    'SYMBOLS': None,
    # Inherit environment variables instead of scrubbing environment.
    'USE_ENVIRON': None,
    # assume we are building via bitcode
    'bitcode': None,
    # enable building of apps that use multi media function
    'build_av_apps': None,
    # set build platform
    'buildplatform': None,
    'build_vim': None,
    'built_elsewhere': None,
    # used for browser_tests
    'chrome_browser_path': None,
    # make sel_ldr less strict
    'dangerous_debug_disable_inner_sandbox': None,
    # disable warning mechanism in src/untrusted/nosys/warning.h
    'disable_nosys_linker_warnings': None,
    # force emulator use by tests
    'force_emulator': None,
    # force sel_ldr use by tests
    'force_sel_ldr': None,
    # TODO(dpolukhin): remove this code when x86-64 has full sel_ldr.
    'loader': None,
    # colon-separated list of compiler flags, e.g. "-g:-Wall".
    'nacl_ccflags': None,
    # colon-separated list of linker flags, e.g. "-lfoo:-Wl,-u,bar".
    'nacl_linkflags': None,
    'naclsdk_mode': None,
    'naclsdk_validate': None,
    # build only C libraries, skip C++, used during SDK build
    'nocpp': None,
    # set both targetplatform and buildplatform
    'platform': None,
    # enable pretty printing
    'pp': None,
    'prebuilt': None,
    # Run tests under this tool (e.g. valgrind, tsan, strace, etc).
    # If the tool has options, pass them after comma: 'tool,--opt1,--opt2'.
    # NB: no way to use tools the names or the args of
    # which contains a comma.
    'run_under': None,
    # Multiply timeout values by this number.
    'scale_timeout': None,
    'sdl': None,
    # disable printing of sys info with sysinfo=
    'sysinfo': None,
    # set target platform
    'targetplatform': None,
    # changes tests behaviour in a way suitable for valgrind
    'running_on_valgrind': False,
    # activates buildbot-specific presets
    'buildbot': None,
    # werror=0 allows "-Werror" (warnings as errors) to be omitted.
    'werror': None,
    # link with valgrind untrusted bits
    'with_valgrind': False,
    # use_libcrypto=0 allows use of -lcrypt to be disabled, which
    # makes it easier to build x86-32 NaCl on x86-64 Ubuntu Linux,
    # where there is no -dev package for the 32-bit libcrypto.
    'use_libcrypto': None,
  }

def CheckArguments():
  for key in ARGUMENTS:
    if key not in ACCEPTABLE_ARGUMENTS:
      print 'ERROR'
      print 'ERROR bad argument: %s' % key
      print 'ERROR'
      sys.exit(-1)


# Sets a command line argument. Dies if an argument with this name is already
# defined.
def SetArgument(key, value):
  print '    %s=%s' % (key, str(value))
  if ARGUMENTS.has_key(key):
    print 'ERROR: %s redefined' % (key, )
    sys.exit(-1)
  else:
    ARGUMENTS[key] = value

# Expands "macro" command line arguments.
def ExpandArguments():
  if ARGUMENTS.get('buildbot') == 'memcheck':
    print 'builbot=memcheck expands to the following arguments:'
    SetArgument('run_under',
                'src/third_party/valgrind/bin/memcheck.sh,' +
                '--suppressions=src/third_party/valgrind/nacl.supp,' +
                '--error-exitcode=1')
    SetArgument('scale_timeout', 20)
    SetArgument('running_on_valgrind', True)
    SetArgument('with_valgrind', True)
  elif ARGUMENTS.get('buildbot') == 'tsan':
    print 'builbot=tsan expands to the following arguments:'
    SetArgument('run_under',
                'src/third_party/valgrind/bin/tsan.sh,' +
                '--suppressions=src/third_party/valgrind/nacl.supp,' +
                '--ignore=src/third_party/valgrind/nacl.ignore,' +
                '--nacl-untrusted,--error-exitcode=1')
    SetArgument('scale_timeout', 20)
    SetArgument('running_on_valgrind', True)
    SetArgument('with_valgrind', True)
  elif ARGUMENTS.get('buildbot'):
    print 'ERROR: unexpected argument buildbot="%s"' % (
        ARGUMENTS.get('buildbot'), )
    sys.exit(-1)

#-----------------------------------------------------------
ExpandArguments()

if int(ARGUMENTS.get('werror', 1)):
  werror_flags = ['-Werror']
else:
  werror_flags = []

# ----------------------------------------------------------
environment_list = []

# ----------------------------------------------------------
# Base environment for both nacl and non-nacl variants.
pre_base_env = Environment(
    tools = ['component_setup'],
    # SOURCE_ROOT is one leave above the native_client directory.
    SOURCE_ROOT = Dir('#/..').abspath,
    # Publish dlls as final products (to staging).
    COMPONENT_LIBRARY_PUBLISH = True,

    # Use workaround in special scons version.
    LIBS_STRICT = True,
    LIBS_DO_SUBST = True,
)

# Scons normally wants to scrub the environment.  However, sometimes
# we want to allow PATH and other variables through so that Scons
# scripts can find nacl-gcc without needing a Scons-specific argument.
if int(ARGUMENTS.get('USE_ENVIRON', '0')):
  pre_base_env['ENV'] = os.environ.copy()

# We want to pull CYGWIN setup in our environment or at least set flag
# nodosfilewarning. It does not do anything when CYGWIN is not involved
# so let's do it in all cases.
pre_base_env['ENV']['CYGWIN'] = os.environ.get('CYGWIN', 'nodosfilewarning')


# ----------------------------------------------------------
# Method to make sure -pedantic, etc, are not stripped from the
# default env, since occasionally an engineer will be tempted down the
# dark -- but wide and well-trodden -- path of expediency and stray
# from the path of correctness.

def EnsureRequiredBuildWarnings(env):
  if env.Bit('linux') or env.Bit('mac'):
    required_env_flags = sets.Set(['-pedantic', '-Wall'] + werror_flags)
    ccflags = sets.Set(env.get('CCFLAGS'))

    if not required_env_flags.issubset(ccflags):
      raise UserError('required build flags missing: '
                      + ' '.join(required_env_flags.difference(ccflags)))
  else:
    # windows get a pass for now
    pass

pre_base_env.AddMethod(EnsureRequiredBuildWarnings)


# ----------------------------------------------------------
# Generic Test Wrapper
# all test suites know so far
TEST_SUITES = {'all_tests': None}



# ----------------------------------------------------------
# Add list of Flaky or Bad tests to skip per platform.  A
# platform is defined as build type
# <BUILD_TYPE>-<SUBARCH>
bad_build_lists = dict()
bad_build_lists['opt-win-64'] = ['ncval_test_call_long_dis',
                                 'run_srpc_basic_test',
                                 'run_srpc_bad_service_test']

bad_build_lists['dbg-win-64'] = ['ncval_test_call_long_dis',
                                 'run_srpc_basic_test',
                                 'run_srpc_bad_service_test']

# ----------------------------------------------------------
# Generic Test Wrapper
# all test suites know so far

def AddNodeToTestSuite(env, node, suite_name, node_name=None):
  build = env['BUILD_TYPE']

  # If we are testing 'NACL' we really need the trusted info
  if build=='nacl' and 'TRUSTED_ENV' in env:
    trusted = env['TRUSTED_ENV']
    build = trusted['BUILD_TYPE']
    subarch = trusted['BUILD_SUBARCH']
  else:
    subarch = env['BUILD_SUBARCH']

  # Build the test platform string
  platform = build + '-' + subarch

  if not node:
    return

  # There are no known-to-fail tests any more, but this code is left
  # in so that if/when we port to a new architecture or add a test
  # that is known to fail on some platform(s), we can continue to have
  # a central location to disable tests from running.  NB: tests that
  # don't *build* on some platforms need to be omitted in another way.

  # Retrieve list of tests to skip on this platform
  skiplist = bad_build_lists.get(platform,[])

  if node_name in skiplist:
    print '*** SKIPPING ', platform, ':', node_name
    return

  AlwaysBuild(node)
  env.Alias('all_tests', node)
  for s in suite_name:
    if s not in TEST_SUITES:
      TEST_SUITES[s] = None
    env.Alias(s, node)
  if node_name:
    env.ComponentTestOutput(node_name, node)

pre_base_env.AddMethod(AddNodeToTestSuite)

# ----------------------------------------------------------
# Convenient testing aliases
# NOTE: work around for scons non-determinism in the following two lines
Alias('small_tests', [])
Alias('medium_tests', [])
Alias('large_tests', [])
Alias('browser_tests', [])

Alias('unit_tests', 'small_tests')
Alias('smoke_tests', ['small_tests', 'medium_tests'])

Alias('memcheck_bot_tests', 'small_tests')
Alias('tsan_bot_tests', [])

# ----------------------------------------------------------
def Banner(text):
  print '=' * 70
  print text
  print '=' * 70

pre_base_env.AddMethod(Banner)

# ----------------------------------------------------------
# PLATFORM LOGIC
# ----------------------------------------------------------
# Define the build and target platforms, and use them to define the path
# for the scons-out directory (aka TARGET_ROOT)
#.
# We have "build" and "target" platforms for the non nacl environments
# which govern service runtime, validator, etc.
#
# "build" means the  platform the code is running on
# "target" means the platform the validator is checking for.
# Typically they are the same but testing it useful to have flexibility.
#
# Various variables in the scons environment are related to this, e.g.
#
# BUILD_ARCH: (arm, x86)
# BUILD_SUBARCH: (32, 64)
#
# The settings can be controlled using scons command line variables:
#
#
# buildplatform=: controls the build platform
# targetplatform=: controls the target platform
# platform=: controls both
#
# This dictionary is used to translate from a platform name to a
# (arch, subarch) pair
AVAILABLE_PLATFORMS = {
    'x86-32' : { 'arch' : 'x86' , 'subarch' : '32' },
    'x86-64' : { 'arch' : 'x86' , 'subarch' : '64' },
    'arm'    : { 'arch' : 'arm' , 'subarch' : '32' }
    }

# Look up the platform name from the command line arguments,
# defaulting to 'platform' if needed.
def GetPlatform(name):
  platform = ARGUMENTS.get(name)
  if platform is None:
    return ARGUMENTS.get('platform', 'x86-32')
  elif ARGUMENTS.get('platform') is None:
    return platform
  else:
    Banner("Can't specify both %s and %s on the command line"
           % ('platform', name))
    assert 0

# Decode platform into list [ ARCHITECTURE , EXEC_MODE ].
def DecodePlatform(platform):
  if platform in AVAILABLE_PLATFORMS:
