=== src/native_client/tests/npapi_hw/Makefile ===
# Copyright 2008, Google Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#
# simple GNU Makefile for simple NPAPI demo
# (Linux, Mac & Cygwin)
#
# Please see googleclient/native_client/common/Makefile.mk for details

CCFLAGS=-Wall -Werror
NAME:=npapi_hw
FILES:=npapi_hw.c npp_gate.c
CLIENT:=$(filter-out *%,$(subst /googleclient,/googleclient *,$(CURDIR)))
LIBS:= -L$(CLIENT)/native_client/scons-out/nacl/lib
LIBS+= -lgoogle_nacl_npruntime
LIBS+= -lgoogle_nacl_imc
INCLUDE:= -I$(CLIENT)/native_client/src/shared/npruntime
INCLUDE+= -I$(CLIENT)/third_party/npapi/files/include
INCLUDE+= -I$(CLIENT)/third_party/npapi/files
ifeq (nacl,$(filter nacl,$(MAKECMDGOALS)))
  POST_BUILD= cp $(EXE_NAME) npapi_hw
endif

include $(CLIENT)/native_client/common/Makefile.mk
