## chromium-browser 1snap1-0ubuntu2

=== debian/changelog ===
chromium-browser (2:1snap1-0ubuntu2) noble; urgency=low

  * d/control: Add chromium to Provides (LP:2060094).
    - An autosynced Debian package added a dependency on it.
      Thanks to Jemery Bicha for noticing and suggesting the change.

 -- Nathan Pratta Teodosio <nathan.teodosio@canonical.com>  Wed, 03 Apr 2024 08:42:36 +0200
